import { ComponentCreator } from './component';
import { ContextCreator } from './create-context';
declare type GenericRenderer = (this: unknown, ...args: any[]) => unknown | void;
declare type RenderFunction = (result: unknown, container: DocumentFragment | Element) => void;
interface Options {
    render: RenderFunction;
}
declare function haunted({ render }: Options): {
    component: ComponentCreator;
    createContext: ContextCreator;
};
export { haunted as default, Options, GenericRenderer, RenderFunction };
export { useCallback } from './use-callback';
export { useEffect } from './use-effect';
export { useLayoutEffect } from './use-layout-effect';
export { useState } from './use-state';
export { useReducer } from './use-reducer';
export { useMemo } from './use-memo';
export { useContext } from './use-context';
export { useRef } from './use-ref';
export { hook, Hook } from './hook';
export { BaseScheduler } from './scheduler';
export { State } from './state';
